## ?q=aHR0cHM6Ly9naXRodWIuY29tL0ZMT1JHMS9yaGVhL2FyY2hpdmUvcmVmcy90YWdzLzAuMi40LnppcA

=== CMakeLists.txt ===
project(rhea)
cmake_minimum_required(VERSION 2.8.3)

set(SOVERSION     "1")
set(VERSION_MAJOR "0")
set(VERSION_MINOR "2")
set(VERSION_PATCH "4")
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

set(CPACK_PACKAGE_NAME "librhea${SOVERSION}")

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build (Debug or Release)" FORCE)
endif()

set(BUILD_UNITTESTS 0 CACHE BOOL "Build the unit tests")
set(BUILD_COVERAGE  0 CACHE BOOL "Generate a coverage report (gcc only)")
set(BUILD_DOCUMENTATION 0 CACHE BOOL "Generate Doxygen documentation")

# Prevent problems with RPATH on mac
#
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif()
set(CMAKE_MACOSX_RPATH ON)

# Set up the compiler
#
if(MSVC)
    add_definitions(/D_WIN32_WINNT=0x0501 /D_CRT_SECURE_NO_WARNINGS /DSFML_STATIC)
    set(CMAKE_CXX_FLAGS         "${CMAKE_CXX_FLAGS} /MP /EHsc /wd4244 /wd4996 ")
    set(CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /DNDEBUG /MT /MP /GS- /Ox /Ob2 /Oi /Oy /arch:SSE /fp:fast /Zi")
    set(CMAKE_LIB_LINKER_FLAGS  "${CMAKE_LIB_LINKER_FLAGS} /OPT:REF /SUBSYSTEM:WINDOWS")

else() # Most likely gcc or clang
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    elseif ("${CMAKE_CXX_COMPILER_VERSION}" VERSION_LESS "4.7")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    endif()

    if (BUILD_COVERAGE AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    endif()

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wall -Wno-strict-aliasing")
    set(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG")
    set(CMAKE_CXX_FLAGS_DEBUG   "-g")
endif()

add_subdirectory(rhea)

if(BUILD_UNITTESTS)
  add_subdirectory(unit_tests)
endif()

# Doxygen documentation
#
if(BUILD_DOCUMENTATION)
  find_package(Doxygen)
  if (DOXYGEN_FOUND STREQUAL "YES")
      configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
      add_custom_target(doxygen ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
      set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES api-doc)
      get_target_property(DOC_TARGET doc TYPE)
      if (NOT DOC_TARGET)
          add_custom_target(doc)
      endif()
      add_dependencies(doc doxygen)
  endif()
endif()

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Incremental constraint solver C++ library")
set(CPACK_PACKAGE_DESCRIPTION "Rhea is a constraint solver that is especially useful for creating user interfaces.  It is based on Cassowary.")
set(CPACK_PACKAGE_VENDOR "Nocte")
set(CPACK_PACKAGE_CONTACT "Nocte <nocte@hippie.nu>")
set(CPACK_SOURCE_IGNORE_FILES "CMakefiles;Makefile;CMakeCache.txt;_CPack_Packages;/.git/;.gitignore;")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}_${VERSION}")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}")

if(UNIX)
    set(CPACK_GENERATOR "DEB")
    add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

    set(CPACK_DEBIAN_PACKAGE_SECTION "devel")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.0), libstdc++6 (>= 4.0)")
    add_custom_target(deb dpkg-buildpackage)
    add_dependencies(deb dist)

elseif(WIN32)
    set(CPACK_GENERATOR "ZIP")
endif()

include(CPack)

=== doc/requirements.txt ===
breathe

=== rhea/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.3)
set(LIBNAME rhea)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.hpp.in ${CMAKE_CURRENT_SOURCE_DIR}/version.hpp)
file(GLOB SOURCE_FILES "*.cpp")
file(GLOB HEADER_FILES "*.hpp")

set (LIBNAME_S "${LIBNAME}-s")
add_library(${LIBNAME_S} STATIC ${SOURCE_FILES} ${HEADER_FILES})
add_library(${LIBNAME}   SHARED ${SOURCE_FILES} ${HEADER_FILES})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VERSION} SOVERSION ${SOVERSION})

install(TARGETS ${LIBNAME_S} ${LIBNAME} DESTINATION lib)
install(FILES ${HEADER_FILES} DESTINATION include/rhea)

=== unit_tests/CMakeLists.txt ===
project (unit-tests)
cmake_minimum_required (VERSION 2.8.3)
set(EXE unit_tests)

add_executable(${EXE} unit_tests.cpp)
# add_executable(speed_test speed_test.cpp)

include_directories(..)

find_package(Boost 1.46 REQUIRED COMPONENTS unit_test_framework)

include_directories(${Boost_INCLUDE_DIRS})

target_link_libraries(${EXE} rhea ${Boost_LIBRARIES})
if(BUILD_COVERAGE AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  target_link_libraries(${EXE} -fprofile-arcs -ftest-coverage)
endif()

# target_link_libraries(speed_test rhea)

=== debian/changelog ===
rhea (0.2.4) raring; urgency=medium

  * More flexibility in adding/removing edit constraints

 -- Nocte <nocte@hippie.nu>  Thu, 12 Feb 2015 19:16:13 +0100

rhea (0.2.3) raring; urgency=medium

  * Bugfix: throw when denominator is not constant (#26)

 -- Nocte <nocte@hippie.nu>  Thu, 27 Nov 2014 09:20:54 +0100

rhea (0.2.2) raring; urgency=medium

  * Renamed COPYING to LICENSE.md

 -- Nocte <nocte@hippie.nu>  Wed, 05 Nov 2014 22:24:57 +0100

rhea (0.2.1) raring; urgency=medium

  * Changed the license to MIT/Expat.

 -- Nocte <nocte@hippie.nu>  Wed, 05 Nov 2014 22:03:58 +0100

rhea (0.2.0) raring; urgency=medium

  * Add linked and action variables.

 -- Nocte <nocte@hippie.nu>  Mon, 20 Oct 2014 21:46:28 +0200

rhea (0.1.6) raring; urgency=low

  * Fix a bug with required strength stays and edits (#18).

 -- Nocte <nocte@hippie.nu>  Mon, 20 Oct 2014 19:28:18 +0200

rhea (0.1.4) raring; urgency=low

  * Fix for Launchpad.

 -- Nocte <nocte@outlook.com>  Mon, 02 Jun 2014 22:40:56 +0200

rhea (0.1.3) raring; urgency=low

  * Formatting with clang-format.

 -- Nocte <nocte@outlook.com>  Mon, 02 Jun 2014 21:08:29 +0200

rhea (0.1.2) raring; urgency=low

  * Small fixes for Debian packaging.

 -- Nocte <nocte@hippie.nu>  Sat, 08 Jun 2013 12:30:37 +0200

rhea (0.1.1) raring; urgency=low

  * Initial release.

 -- Nocte <nocte@hippie.nu>  Tue, 04 Jun 2013 13:58:45 +0200

=== debian/control ===
Source: rhea
Maintainer: Nocte <nocte@hippie.nu>
Section: libs
Priority: optional
Build-Depends: 
 debhelper (>= 9), 
 cmake (>= 2.8), 
 cdbs, 
 libboost-dev (>= 1.47)
Standards-Version: 3.9.4
Homepage: http://github.com/Nocte-/rhea

Package: librhea1-dev
Section: libdevel
Architecture: any
Depends: 
 librhea1 (= ${binary:Version}), 
 ${misc:Depends}
Description: Linear constraint solver library
 Simplex linear constraint solver in C++11, based on the Cassowary library.

Package: librhea1
Section: libs
Architecture: any
Depends: 
 ${shlibs:Depends}, 
 ${misc:Depends}
Description: Linear constraint solver library
 Simplex linear constraint solver in C++11, based on the Cassowary library.
